=== Clients/PythonCatalyst/Testing/CMakeLists.txt ===
#--------------------------------------------------------------------
# Process old tests before Catalyst refactoring.
add_subdirectory(Legacy)

#---------------------------------------------------------------------
# New testing stuff is here
vtk_module_test_data(

  # Data files
  "DATA{${paraview_test_data_directory_input}/Data/Wavelet/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/Wavelet/Wavelet1_000000/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/Wavelet/Wavelet1_000001/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/Wavelet/Wavelet1_000002/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/Wavelet/Wavelet1_000003/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/Wavelet/Wavelet1_000004/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/Wavelet/Wavelet1_000005/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/Wavelet/Wavelet1_000006/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/Wavelet/Wavelet1_000007/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/Wavelet/Wavelet1_000008/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/Wavelet/Wavelet1_000009/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/Wavelet/Wavelet1_000010/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/can_vtm/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/can_vtm/can_0/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/can_vtm/can_1/,REGEX:.*}"
  "DATA{${paraview_test_data_directory_input}/Data/can_vtm/can_2/,REGEX:.*}"

  # baselines for WaveletHistogramExtracts
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_ImmediateExtracts_renderview_0000.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_BatchExtracts_histogram_1.000000.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_CoprocessingExtracts_renderview_0000.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_BatchExtracts_histogram_0.000000.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_ImmediateExtracts_histogram_1.000000.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_ImmediateExtracts_renderview_0008.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_CoprocessingExtracts_histogram_0.950000.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_ImmediateExtracts_histogram_0.000000.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_BatchExtracts_renderview_0000.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_BatchExtracts_renderview_0008.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_CoprocessingExtracts_histogram_0.000000.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_CoprocessingExtracts_renderview_0018.png"

  # baselines for WaveletHistogramExtracts with MPI. The histograms are difference since points along edges are counted twice.
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_BatchExtracts_histogram_0.000000_1.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_BatchExtracts_histogram_1.000000_1.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_CoprocessingExtracts_histogram_0.000000_1.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletHistogramExtracts_CoprocessingExtracts_histogram_0.950000_1.png"

  # baselines for WaveletPhiThetaExtractsWithCinema
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletPhiThetaExtractsWithCinema_BatchExtracts_image_000000p_000.00t_000.00.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletPhiThetaExtractsWithCinema_BatchExtracts_image_000000p_000.00t_060.00.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletPhiThetaExtractsWithCinema_BatchExtracts_image_000001p_000.00t_180.00.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletPhiThetaExtractsWithCinema_BatchExtracts_image_000001p_000.00t_240.00.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletPhiThetaExtractsWithCinema_CoprocessingExtracts_image_000000p_000.00t_000.00.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletPhiThetaExtractsWithCinema_CoprocessingExtracts_image_000000p_000.00t_060.00.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletPhiThetaExtractsWithCinema_CoprocessingExtracts_image_000001p_000.00t_180.00.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletPhiThetaExtractsWithCinema_CoprocessingExtracts_image_000001p_000.00t_240.00.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletPhiThetaExtractsWithCinema_ImmediateExtracts_image_000000p_000.00t_000.00.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletPhiThetaExtractsWithCinema_ImmediateExtracts_image_000000p_000.00t_060.00.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletPhiThetaExtractsWithCinema_ImmediateExtracts_image_000001p_000.00t_000.00.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletPhiThetaExtractsWithCinema_ImmediateExtracts_image_000001p_000.00t_060.00.png"

  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/MultiplePipelines_pipeline1_000001.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/MultiplePipelines_pipeline2_000009.png"

  # baselines for WaveletVolumeRenderWithCinema
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletVolumeRenderWithCinema_BatchExtracts_image_000000otf_0.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletVolumeRenderWithCinema_BatchExtracts_image_000000otf_4.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletVolumeRenderWithCinema_CoprocessingExtracts_image_000000otf_0.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletVolumeRenderWithCinema_CoprocessingExtracts_image_000000otf_4.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletVolumeRenderWithCinema_ImmediateExtracts_image_000000otf_0.png"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletVolumeRenderWithCinema_ImmediateExtracts_image_000000otf_4.png"

  # baselines for WaveletTimeTrigger
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletTimeTrigger_BatchExtracts_RenderView1_000000.png}"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletTimeTrigger_ImmediateExtracts_RenderView1_000000.png}"
  "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline/WaveletTimeTrigger_CoprocessingExtracts_RenderView1_000000.png}"
)

set(simple_scripts
  ValidateChangingInput.py
  CatalystScriptCustomCallbackVerifier.py
  package_test
  package_test_zip.zip)

if (TARGET ParaView::RemotingLive)
  list(APPEND simple_scripts
      LiveOnly.py)
endif()

paraview_add_test(
  PREFIX "Catalyst::WaveletMiniApp"
  ARGS   "$<TARGET_FILE:ParaView::pvbatch>" --dr --sym -- -m paraview.demos.wavelet_miniapp -t 20 --size 21 -s
  TEST_SCRIPTS ${simple_scripts})

# Add test to test for adding the same pipeline script twice.
paraview_add_test(
  PREFIX "Catalyst::WaveletMiniApp"
  ARGS   "$<TARGET_FILE:ParaView::pvbatch>" --dr --sym -- -m paraview.demos.wavelet_miniapp -t 2 --size 21
            --script-version 2
            -s "${CMAKE_CURRENT_SOURCE_DIR}/repeated_pipeline.py"
            -s
            TEST_SCRIPTS "repeated_pipeline.py" )
set_tests_properties("Catalyst::WaveletMiniApp.repeated_pipeline"
  PROPERTIES
  PASS_REGULAR_EXPRESSION "Importing 'repeated_pipeline' for 2-th time!")

paraview_add_test_mpi(
  PREFIX "Catalyst::MPI::WaveletMiniApp"
  ARGS   "$<TARGET_FILE:ParaView::pvbatch>" --dr --sym -- -m paraview.demos.wavelet_miniapp -t 20 --size 21 -s
  TEST_SCRIPTS ${simple_scripts})

# Add test to test for adding the same pipeline script twice.
paraview_add_test_mpi(
  PREFIX "Catalyst::MPI::WaveletMiniApp"
  ARGS   "$<TARGET_FILE:ParaView::pvbatch>" --dr --sym -- -m paraview.demos.wavelet_miniapp -t 2 --size 21
          --script-version 2
          -s "${CMAKE_CURRENT_SOURCE_DIR}/repeated_pipeline.py"
          -s
          TEST_SCRIPTS "repeated_pipeline.py" )
if (PARAVIEW_USE_MPI)
  set_tests_properties("Catalyst::MPI::WaveletMiniApp.repeated_pipeline"
    PROPERTIES
    PASS_REGULAR_EXPRESSION "Importing 'repeated_pipeline' for 2-th time!")
endif()

foreach (tname IN LISTS scripts)
  set_tests_properties("Catalyst::WaveletMiniApp.${tname}"
    PROPERTIES
    PASS_REGULAR_EXPRESSION "All ok")
  if (PARAVIEW_USE_MPI)
    set_tests_properties("Catalyst::MPI::WaveletMiniApp.${tname}"
      PROPERTIES
        PASS_REGULAR_EXPRESSION "All ok")
  endif()
endforeach()

if (TARGET ParaView::RemotingViews)
  #--------------------------------------------------------------------
  # add test to validate multiple analysis pipelines can be used.
  add_test(NAME Catalyst::WaveletMiniApp::MultiplePipelines::Prepare
           COMMAND "${CMAKE_COMMAND}" -E remove_directory "${CMAKE_BINARY_DIR}/Testing/Temporary/MultiplePipelines")
  set_tests_properties(
    "Catalyst::WaveletMiniApp::MultiplePipelines::Prepare"
    PROPERTIES
      FIXTURES_SETUP "Catalyst::WaveletMiniApp::MultiplePipelines::Prepare")
  paraview_add_test(
      PREFIX "Catalyst::WaveletMiniApp::MultiplePipelines::pipeline1"
      ENVIRONMENT
        PARAVIEW_OVERRIDE_EXTRACTS_OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}/Testing/Temporary/MultiplePipelines/
      ARGS   "$<TARGET_FILE:ParaView::pvbatch>"
             --sym
             --dr
             --
             -m paraview.demos.wavelet_miniapp -t 10 --size 21
             --channel Wavelet1
             -s "${CMAKE_CURRENT_SOURCE_DIR}/pipeline1.py"
             -s
      TEST_SCRIPTS "${CMAKE_CURRENT_SOURCE_DIR}/pipeline2.py")
  set_tests_properties(
    "Catalyst::WaveletMiniApp::MultiplePipelines::pipeline1.pipeline2"
    PROPERTIES
      FIXTURES_REQUIRED "Catalyst::WaveletMiniApp::MultiplePipelines::Prepare")

  paraview_add_test(
      PREFIX "Catalyst::WaveletMiniApp::MultiplePipelines::Validate::pipeline1"
      ARGS   "$<TARGET_FILE:ParaView::pvpython>"
             --dr
             --
             -m paraview.tests.validate_extracts
             --name MultiplePipelines
             --root "${CMAKE_BINARY_DIR}/Testing/Temporary/MultiplePipelines"
             --baseline-dir "${paraview_test_data_directory_output}/Clients/PythonCatalyst/Testing/Data/Baseline"
             --temp-dir "${CMAKE_BINARY_DIR}/Testing/Temporary"
             --json
      TEST_SCRIPTS "${CMAKE_CURRENT_SOURCE_DIR}/pipeline2.json")
  set_tests_properties(
      "Catalyst::WaveletMiniApp::MultiplePipelines::Validate::pipeline1.pipeline2"
      PROPERTIES DEPENDS
        "Catalyst::WaveletMiniApp::MultiplePipelines::pipeline1.pipeline2")
endif()

#---------------------------------------------------------------------
# add tests for filedriver_miniapp
set(filedriver_tests
   ValidateChangingTime.py)

if (NOT PARAVIEW_SERIAL_TESTS_USE_MPIEXEC)
  # if PARAVIEW_SERIAL_TESTS_USE_MPIEXEC, the paraview_add_test_mpi
  # call and this will be duplicates, so no need to do these here.
  paraview_add_test(
    PREFIX "Catalyst::FileDriverMiniApp::Wavelet"
    ARGS  "$<TARGET_FILE:ParaView::pvbatch>" --dr --sym --
          -m paraview.demos.filedriver_miniapp
          -g "${paraview_test_data_directory_output}/Testing/Data/Wavelet/*.pvti"
          -s
    TEST_SCRIPTS ${filedriver_tests})

  paraview_add_test(
    PREFIX "Catalyst::FileDriverMiniApp::Can"
    ARGS  "$<TARGET_FILE:ParaView::pvbatch>" --dr --sym --
          -m paraview.demos.filedriver_miniapp
          -g "${paraview_test_data_directory_output}/Testing/Data/can_vtm/*.vtm"
          -s
    TEST_SCRIPTS ${filedriver_tests})
endif()

paraview_add_test_mpi(
  PREFIX "Catalyst::MPI::FileDriverMiniApp::Wavelet"
  ARGS  "$<TARGET_FILE:ParaView::pvbatch>" --dr --sym --
        -m paraview.demos.filedriver_miniapp
